import { Asset, IInitOptions, Resolver } from 'jgb-shared/lib';
import { IAssetGenerate, IDepOptions } from 'jgb-shared/lib/Asset';
import Compiler from './Compiler';
export interface IPipelineProcessed {
    id: string;
    dependencies: IDepOptions[];
    hash: string;
    cacheData?: any;
    generated: IAssetGenerate | IAssetGenerate[];
}
export default class Pipeline {
    private options;
    compiler: Compiler;
    initPromise: Promise<any>;
    resolver: Resolver;
    constructor(options: IInitOptions);
    process(path: Asset | string, distPath: string, isWarmUp: boolean): Promise<IPipelineProcessed>;
    processAsset(asset: Asset): Promise<IAssetGenerate | IAssetGenerate[]>;
}
